#! CRADDON 1
#! NAME Cowardice
#! DESCRIPTION Allow one-click guest posting of news. Guest accounts must start with "guest_"<br>written by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a><br><a href="http://www.wwddfd.com/">perl garden</a>
#! VERSION build 1
#! DOC 1

#
# Allows guest posting of news. Guest accounts must start with "guest_"
# written by Tricia McFarlane
# plushpuffin@wwddfd.com
# http://www.wwddfd.com/
#

# Will compile & work with the following:
#use strict;
#use vars qw(%Subs %in %CConfig $HTMLHeaderPrinted, $up, $uname);

my $addon = new Addon('Cowardice');
$addon->checkBuild(19);
$addon->registerAdminFunction('cowardicesubmit', 'CowardiceSubmit');
$addon->registerAdminFunction('cowardice', 'CowardiceRequest');
$addon->addAdminFunction('Cowardice', 'Retrieve the HTML code necessary to invoke Cowardice', 'cowardice');



# CowardiceRequest: Display Cowardice User Selection Screen.
$Subs{'CowardiceRequest'} = << 'END_SUB';
sub CowardiceRequest {
	my $addon = shift;
	$addon->pageHeader('Cowardice HTML Generation', 1);
	print $addon->descParagraph(q~Type the account name and password of a guest account to use for anonymous submission of news.~),
	$addon->form({'action' => 'admin', 'adminarea' => 'cowardicesubmit'});
	print qq~
<br><input type="text" name="guest_name" value="guest_name" size="32">
<br><input type="password" name="guest_pass" value="" size="32">
	<br><div align="center"><input type="submit" name="submit" value="Submit"></div>
	</form>
	~;
	$addon->pageFooter();
}
END_SUB

# CowardiceSubmit: Display Cowardice HTML code generated from input.
$Subs{'CowardiceSubmit'} = << 'END_SUB';
sub CowardiceSubmit {
	my $addon = shift;
	if( $in{'guest_name'} !~ /\Aguest/ ) {
		$addon->simplePage('Invalid guest account', 'The guest account must start with the word "guest"' .
		$addon->link({'action' => 'admin', 'adminarea' => 'cowardice'}) . 
		'Back to Cowardice</a>.', 1);
		return;
	}
	my $textcut = '';
	tie *$textcut, 'Tie::FHRS', \$textcut;
	my $innertube = select $textcut;
	my $tmpup = $up;
	$up = 1;
	&DisplaySubForm;
	$up = $tmpup;
	select $innertube;
	untie $textcut;
	my $replacecut = qq~
<input type="hidden" name="action" value="login">
<input type="hidden" name="secondaryaction" value="submitsave">
<input type="hidden" name="uname" value="$in{'guest_name'}">
<input type="hidden" name="pword" value="$in{'guest_pass'}">
~;
	$textcut =~ s~\A.*(\Q<form action\E.*?)\Q<input type="hidden" name="action" value="submitsave">\E~$1$replacecut~s;
	$textcut =~ s~\Q<input type="hidden" name="session" value="\E\w+\Q">\E~~;
	$textcut =~ s~</form>.*\Z~\n</form>~s;
	$textcut =~ s~\Q<tr><td width="30%" class="fieldtitle" valign="top"><div align="right">Date:</div></td>\E\n\t\Q<td width="70%">\E.*?\Q</td></tr>\E~~s;
	$textcut =~ s~\n\t+~\n~g;
	$HTMLHeaderPrinted = 0;
	$addon->pageHeader( 'Cowardice HTML Generated', 1 );
	print $addon->descParagraph( qq~Copy and paste the text in the textbox into an HTML page of your choice.
	The page does not even have to be on the same server as your Coranto installation.~ );
	print qq~<textarea name="cutnpaste" rows="$fieldDB{'Text'}->{'FieldRows'}" cols="$fieldDB{'Text'}->{'FieldCols'}" wrap="VIRTUAL" style="width:100%">~;
	print &HTMLescape( $textcut );
	print '</textarea>';
	$addon->pageFooter();
}
END_SUB

my $Cowardice_EarlyHook = << 'END_CODE';
	if( $up < 3 ) {
		$in{'CustomField_PosterIP'} = $ENV{'REMOTE_ADDR'};
		$CustomField_PosterIP = $in{'CustomField_PosterIP'};
	}
	else {
		$in{'CustomField_PosterIP'} ||= $ENV{'REMOTE_ADDR'};
	}
	if( $in{'action'} eq 'login' && $Sessions{$CurrentSession}->[0] =~ m~\Aguest~ && $in{'secondaryaction'} eq 'submitsave' ) {
		$in{'action'} = 'submitsave';
		push(@AvailableFunctions,
			[$Messages{'Section_LogOut'}, $Messages{'Desc_LogOut'}, 'logout']);
		&SaveNews;
		untie(%CConfig);
		exit;
	}
END_CODE

$addon->hook('EarlyHook', \$Cowardice_EarlyHook, 9);

1;
#####################################################
package Tie::FHRS;
sub TIEHANDLE {
	my $class = shift;
	my $self = shift;

	return bless $self, $class;
}

sub PRINT {
	my $self = shift;
	$$self .= join('', @_);
	return 1;
}
1;
#####################################################

__END__

=head1 Cowardice

=head2 SETUP

=over 4

=item *

Enable the addon.

=item *

Create a guest account starting with "guest" and ending with whatever you want. (eg: guest_uninvited, guestburger, guest_guest, guestofwind)

=item *

Create a new news field called "CustomField_PosterIP" of type "Single line text box" and set the permissions on it to "Administrators Only" for both Submit and Modify.

=back

=head2 SUBMISSION

=over 4

=item *

Go to the Cowardice page in the Administration section.

=item *

Enter a guest account name and valid password in the provided text box, click submit, and voila.

=item *

Copy the text provided to you and paste it into an HTML document.

=item *

Test the form by launching your browser, filling in the form on your HTML document, and click submit news.

=back

=head2 ABOUT THE AUTHOR

=over 4

=item *

name: Tricia McFarlane

=item *

email: plushpuffin@wwddfd.com

=item *

site: http://www.wwddfd.com/

=back